#include <amxmodx>
#include <amxmisc>
#include <codmod>
#include <hamsandwich>
#include <engine>

new sprite;

new ilosc_blyskawic[33],poprzednia_blyskawica[33];

new const gszSound[] = "ambience/thunder_clap.wav";
        
new const nazwa[]   = "Aspirant";
new const opis[]    = "1/9 z USP";
new const bronie    = (1<<CSW_USP);
new const zdrowie   = 10;
new const kondycja  = 5;
new const inteligencja = 0;
new const wytrzymalosc = 5;
new ma_klase[33]
new oneonone[33][31]

public plugin_init()
{
	register_plugin(nazwa, "1.0", "amxx.pl");

	cod_register_advance(cod_get_classid("Sierzant"), 3400, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage");
	register_clcmd("blysk", "cmdBlyskawica");
	
	register_event("ResetHUD", "ResetHUD", "abe");
}

public plugin_precache()

{

sprite = precache_model("sprites/lgtning.spr");

}

public TakeDamage(this, idinflictor, idattacker, Float:damage, damagebits)
{
	if(!is_user_connected(idattacker))
		return HAM_IGNORED;
	
	if(!ma_klase[idattacker])
		return HAM_IGNORED;
	
	if(!(damagebits & (1<<1)))
		return HAM_IGNORED;
	
	new hp_ofiary = get_user_health(this)
	new bron_atakujacego = get_user_weapon(idattacker)
	
	if (oneonone[idattacker][bron_atakujacego] > 0)
	{
		if (random_num(1,oneonone[idattacker][bron_atakujacego]) == 1) cod_inflict_damage(idattacker, this, float(hp_ofiary), 0.0, idinflictor, damagebits);
	}
	
	return HAM_IGNORED;
}

public cod_class_enabled(id)
{
	oneonone[id][CSW_USP] = 9
	ma_klase[id] = 1;
	ilosc_blyskawic[id] = 3;

	return COD_CONTINUE;
}
public cod_class_disabled(id)
{
	ma_klase[id] = 0;
	oneonone[id][CSW_USP] = 0
	ilosc_blyskawic[id] = 0;
}

public cmdBlyskawica(id){

if(!is_user_alive(id)) return PLUGIN_HANDLED;

if(!ilosc_blyskawic[id]) {

return PLUGIN_HANDLED;

}

if(poprzednia_blyskawica[id]+5.0>get_gametime()) {

client_print(id,print_chat,"Blyskawicy mozesz uzyc raz na 5 sek.");

return PLUGIN_HANDLED;

}

poprzednia_blyskawica[id]=floatround(get_gametime());

ilosc_blyskawic[id]--;

new ofiara, body;

get_user_aiming(id, ofiara, body);



if(is_user_alive(ofiara)){

puscBlyskawice(id, ofiara, 50.0, 0.5);

}

return PLUGIN_HANDLED;

}

stock Create_TE_BEAMENTS(startEntity, endEntity, iSprite, startFrame, frameRate, life, width, noise, red, green, blue, alpha, speed){



message_begin( MSG_BROADCAST, SVC_TEMPENTITY )

write_byte( TE_BEAMENTS )

write_short( startEntity )        // start entity

write_short( endEntity )        // end entity

write_short( iSprite )            // model

write_byte( startFrame )        // starting frame

write_byte( frameRate )            // frame rate

write_byte( life )                // life

write_byte( width )                // line width

write_byte( noise )                // noise amplitude

write_byte( red )                // red

write_byte( green )                // green

write_byte( blue )                // blue

write_byte( alpha )                // brightness

write_byte( speed )                // scroll speed

message_end()

}





puscBlyskawice(id, ofiara, Float:fObrazenia = 55.0, Float:fCzas = 1.0){

//Obrazenia

new ent = create_entity("info_target");

entity_set_string(ent, EV_SZ_classname, "blyskawica");

ExecuteHamB(Ham_TakeDamage, ofiara, ent, id, fObrazenia, DMG_SHOCK);

remove_entity(ent);



//Piorun

Create_TE_BEAMENTS(id, ofiara, sprite, 0, 10, floatround(fCzas*10), 150, 5, 200, 200, 200, 200, 10);



//Dzwiek

emit_sound(id, CHAN_WEAPON, gszSound, VOL_NORM, ATTN_NORM, 0, PITCH_NORM);

}



public ResetHUD(id)

	ilosc_blyskawic[id] = 3;
