#include <amxmodx>

#include <codmod>

#include <fakemeta>

#include <engine>

#include <hamsandwich>

new sprite_blast;
new ilosc_rakiet_gracza[33];
new poprzednia_rakieta_gracza[33];
new bool:ma_klase[33];



new const nazwa[] = "Pradawny Predator";
new const opis[] = "Posiada 2 duchy (200+int(*0.3). Widzi Niewidzialnych.";
new const bronie = 1<<CSW_M249 | 1<<CSW_DEAGLE;
new const zdrowie = 35;
new const kondycja = 10;
new const inteligencja = 0;
new const wytrzymalosc = 10;



public plugin_init() 

{

	register_plugin(nazwa, "1.0", "RPK. Shark");

	register_touch("rocket", "*" , "DotykRakiety");

	cod_register_advance(cod_get_classid("Elitarny Predator"), 3400, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);

	RegisterHam(Ham_Spawn, "player", "fwSpawn_Rakiety", 1);

	register_forward(FM_AddToFullPack, "FwdAddToFullPack", 1)

}

public plugin_precache()
{
	sprite_blast = precache_model("sprites/dexplo.spr");
	precache_model("models/ghost.mdl");
}

public cod_class_enabled(id)

{

	ilosc_rakiet_gracza[id] = 4;
	ma_klase[id] = true;

}



public cod_class_disabled(id)

	ma_klase[id] = false;



public FwdAddToFullPack(es_handle, e, ent, host, hostflags, player, pSet)

{

        if(!is_user_connected(host) || !is_user_connected(ent))

                return;

 

        if(!ma_klase[host])

                return;

 

        set_es(es_handle, ES_RenderAmt, 255.0);

}

public cod_class_skill_used(id)
{
	if (!ilosc_rakiet_gracza[id])
	{
		client_print(id, print_center, "Wykorzystales juz wszystkie Duchy!");
		return PLUGIN_CONTINUE;
	}
	
	if(poprzednia_rakieta_gracza[id] + 2.0 > get_gametime())
	{
		client_print(id, print_center, "Duchow mozesz uzywac co 2 sekundy!");
		return PLUGIN_CONTINUE;
	}
	
	if (is_user_alive(id))
	{
		poprzednia_rakieta_gracza[id] = floatround(get_gametime());
		ilosc_rakiet_gracza[id]--;

		new Float: Origin[3], Float: vAngle[3], Float: Velocity[3];
		
		entity_get_vector(id, EV_VEC_v_angle, vAngle);
		entity_get_vector(id, EV_VEC_origin , Origin);
	
		new Ent = create_entity("info_target");
	
		entity_set_string(Ent, EV_SZ_classname, "rocket");
		entity_set_model(Ent, "models/ghost.mdl");
	
		vAngle[0] *= -1.0;
	
		entity_set_origin(Ent, Origin);
		entity_set_vector(Ent, EV_VEC_angles, vAngle);
	
		entity_set_int(Ent, EV_INT_effects, 2);
		entity_set_int(Ent, EV_INT_solid, SOLID_BBOX);
		entity_set_int(Ent, EV_INT_movetype, MOVETYPE_FLY);
		entity_set_edict(Ent, EV_ENT_owner, id);
	
		VelocityByAim(id, 1000 , Velocity);
		entity_set_vector(Ent, EV_VEC_velocity ,Velocity);
	}	
	return PLUGIN_CONTINUE;
}

public DotykRakiety(ent)
{
	if (!is_valid_ent(ent))
		return;

	new attacker = entity_get_edict(ent, EV_ENT_owner);
	

	new Float:fOrigin[3];
	entity_get_vector(ent, EV_VEC_origin, fOrigin);	
	
	new iOrigin[3];
	for(new i=0;i<3;i++)
		iOrigin[i] = floatround(fOrigin[i]);
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY, iOrigin);
	write_byte(TE_EXPLOSION);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]);
	write_short(sprite_blast);
	write_byte(32); 
	write_byte(20); 
	write_byte(0);
	message_end();

	new entlist[33];
	new numfound = find_sphere_class(ent, "player", 190.0, entlist, 32);
	
	for (new i=0; i < numfound; i++)
	{		
		new pid = entlist[i];
		
		if (!is_user_alive(pid) || get_user_team(attacker) == get_user_team(pid))
			continue;
		cod_inflict_damage(attacker, pid, 200.0, 0.3, ent, (1<<24));
	}
	remove_entity(ent);
}	

public fwSpawn_Rakiety(id)
{
	if(is_user_alive(id))
		ilosc_rakiet_gracza[id] = 4;
}

public client_disconnect(id)
{
	new ent = find_ent_by_class(0, "rocket");
	while(ent > 0)
	{
		if(entity_get_edict(id, EV_ENT_owner) == id)
			remove_entity(ent);
		ent = find_ent_by_class(ent, "rocket");
	}
}