#include <amxmodx>
#include <amxmisc>
#include <codmod>
#include <fakemeta>
#include <hamsandwich>

#define DMG_BULLET (1<<1)

new const nazwa[]   = "Pulkownik";
new const opis[]    = "1/11 z M4A1 oraz AK47";
new const bronie    = (1<<CSW_USP)|(1<<CSW_M4A1)|(1<<CSW_AK47);
new const zdrowie   = 20;
new const kondycja  = 25;
new const inteligencja = 5;
new const wytrzymalosc = 25;
new ma_klase[33]
new oneonone[33][31]
	
public plugin_init()
{
	register_plugin(nazwa, "1.0", "amxx.pl");

	cod_register_advance(cod_get_classid("Kapral"), 3700, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);
	register_event("CurWeapon","CurWeapon","be", "1=1");
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage");
}

public TakeDamage(this, idinflictor, idattacker, Float:damage, damagebits)
{
	if(!is_user_connected(idattacker))
		return HAM_IGNORED;
	
	if(!ma_klase[idattacker])
		return HAM_IGNORED;
	
	if(!(damagebits & (1<<1)))
		return HAM_IGNORED;
	
	new hp_ofiary = get_user_health(this)
	new bron_atakujacego = get_user_weapon(idattacker)
	
	if (oneonone[idattacker][bron_atakujacego] > 0)
	{
		if (random_num(1,oneonone[idattacker][bron_atakujacego]) == 1) cod_inflict_damage(idattacker, this, float(hp_ofiary), 0.0, idinflictor, damagebits);
	}
	
	return HAM_IGNORED;
}

public cod_class_enabled(id)
{
	oneonone[id][CSW_AK47] = 11
	oneonone[id][CSW_M4A1] = 11
	ma_klase[id] = 1;

	return COD_CONTINUE;
}

public cod_class_disabled(id)
{
	ma_klase[id] = 0;
	oneonone[id][CSW_AK47] = 0
	oneonone[id][CSW_M4A1] = 0
}

public CurWeapon(id)
{
	if(!is_user_connected(id))
		return;
	
	if(!ma_klase[id])
		return;
	
	set_user_clip(id, 2);
}
	

stock set_user_clip(id, ammo)
{
	new weaponname[32], weaponid = -1, weapon = get_user_weapon(id, _, _);
	get_weaponname(weapon, weaponname, 31);
	while ((weaponid = engfunc(EngFunc_FindEntityByString, weaponid, "classname", weaponname)) != 0)
		if (pev(weaponid, pev_owner) == id) {
		set_pdata_int(weaponid, 51, ammo, 4);
		return weaponid;
	}
	return 0;
}