#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <codmod>
#include <hamsandwich>
        
new const nazwa[]   = "Tajny Agent";
new const opis[]    = "Posiada ubranie wroga oraz 1/1 na spawn u wroga.";
new const bronie    = (1<<CSW_P90);
new const zdrowie   = 10;
new const kondycja  = 10;
new const inteligencja = 5;
new const wytrzymalosc = 10;

new bool: ma_klase[33];

new CT_Skins[4][] = {"sas","gsg9","urban","gign"};

new Terro_Skins[4][] = {"arctic","leet","guerilla","terror"};
    
public plugin_init()
{
	register_plugin(nazwa, "1.0", "amxx.pl");

	cod_register_advance(cod_get_classid("Agent"), 3200, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);

	RegisterHam(Ham_Spawn, "player", "Spawn", 1);
}

public cod_class_enabled(id)

{

	ZmienUbranie(id, 0);

	ma_klase[id] = true;

}



public cod_class_disabled(id)

{

	ZmienUbranie(id, 1);

	ma_klase[id] = false;

}

public ZmienUbranie(id, reset)
{
    if (!is_user_connected(id))
        return PLUGIN_CONTINUE;
   
    if(reset)
        cs_reset_user_model(id);
    else
    {
        new num = random_num(0,2);
        cs_set_user_model(id, (get_user_team(id) == 1)? CT_Skins[num]: Terro_Skins[num]);
    }
   
    return PLUGIN_CONTINUE;
}

public Spawn(id)
{
    if(!is_user_alive(id))
        return;
       
    if(!ma_klase[id])
        return;
       
    if(random_num(1,1) == 1)
    {
        new CsTeams:team = cs_get_user_team(id);
       
        cs_set_user_team(id, (team == CS_TEAM_CT)? CS_TEAM_T: CS_TEAM_CT);
        ExecuteHam(Ham_CS_RoundRespawn, id);
       
        cs_set_user_team(id, team);
    }
    ZmienUbranie(id, 0);
}